import { useDialog } from 'naive-ui';
import { defineComponent } from 'vue';
import { useRouter } from 'vue-router';

export default defineComponent({
  name: 'router-error',
  setup() {
    const router = useRouter();
    const dialog = useDialog();
    let isOpen = false;




    router.onError((error, to, form) => {
      const str = error.message + '';
      const isChunkLoadFailed = str.indexOf('imported');
      console.log(error, to)
      // const targetPath = router.history.pending.fullPath

      if (isChunkLoadFailed != -1 && !isOpen) {
        isOpen = true;
        dialog.warning({
          title: '更新提示',
          content: '网站有更新请点击确定刷新页面?',
          positiveText: '确定',
          negativeText: '取消',
          onPositiveClick: () => {
            router.push(to)
            window.location.reload();
          }
        });
      }
    });

    const checkNewVersion = async () => {
      if ('serviceWorker' in navigator) {
        // let refreshing = false
        const flag = (await caches.keys()).length > 0;
        console.log(caches.keys(), `0904路由更新有缓存${flag}`);
        caches.keys().then(function (cacheNames) {
          cacheNames.forEach(function (cacheName) {
            caches.delete(cacheName);
          });
          if (flag) {
            window.location.reload();
          }
        });

        // 尝试监听install

        let refreshing = false;
        navigator.serviceWorker.addEventListener('controllerchange', () => {
          console.log('controllerchange');
          if (refreshing) {
            return;
          }
          refreshing = true;
          window.location.reload();
        });
      }
    }

    checkNewVersion()
    return () => <div></div>;
  }
});
